package org.netkernel.xml.accessor;

import java.io.ByteArrayOutputStream;
import java.io.OutputStreamWriter;

import org.netkernel.layer0.nkf.INKFRequestContext;
import org.netkernel.layer0.nkf.INKFResponse;
import org.netkernel.layer0.nkf.INKFResponseReadOnly;
import org.netkernel.layer0.representation.ByteArrayRepresentation;
import org.netkernel.layer0.util.XMLReadable;
import org.netkernel.module.standard.endpoint.StandardAccessorImpl;
import org.netkernel.xml.util.XMLUtils;
import org.w3c.dom.Document;

public class ActiveDOMSerializer extends StandardAccessorImpl
{
	public ActiveDOMSerializer()
	{
		this.declareThreadSafe();
	}

	@Override
	public void onSource(INKFRequestContext context) throws Exception
	{	boolean indent=true;
		boolean omit=false;
		String encoding="UTF-8";
		if(context.getThisRequest().argumentExists("operator"))
		{	Document opt=context.source("arg:operator", Document.class);
			XMLReadable xr=new XMLReadable(opt);
			indent=xr.getFirstNode("/serialize/indent")!=null;
			omit=xr.getFirstNode("/serialize/omit-declaration")!=null;
			if(xr.getFirstNode("/serialize/encoding")!=null)
			{	encoding=xr.getTrimText("/serialize/encoding");
			}
		}
		ByteArrayOutputStream baos=new ByteArrayOutputStream(2048);
		OutputStreamWriter osw=new OutputStreamWriter(baos, encoding);
		INKFResponseReadOnly<Document> opd=context.sourceForResponse("arg:operand", Document.class);
		XMLUtils.toXML(osw, opd.getRepresentation(),indent, omit, encoding);
		INKFResponse resp=context.createResponseFrom(new ByteArrayRepresentation(baos.toByteArray()));
		String mimetype=opd.getMimeType();
		if(mimetype==null)
		{	mimetype="text/xml";			
		}
		resp.setMimeType(mimetype);
	}
}
