package org.netkernel.xml.accessor.schema;

import javax.xml.transform.dom.DOMSource;
import javax.xml.validation.Validator;

import org.netkernel.layer0.nkf.INKFRequestContext;
import org.netkernel.module.standard.endpoint.StandardAccessorImpl;
import org.w3c.dom.Document;
import org.xml.sax.SAXException;

public class ValidateXSDAccessor extends StandardAccessorImpl
{
	public ValidateXSDAccessor()
	{	this.declareThreadSafe();
	}

	@Override
	public void onSource(INKFRequestContext context) throws Exception
	{	Document opd=(Document)context.source("arg:operand", Document.class);
		XSDSchemaRep sr=(XSDSchemaRep)context.source("arg:operator", XSDSchemaRep.class);
	    Validator validator = sr.getValidator();
	    boolean valid=true;
	    try
	    {	validator.validate(new DOMSource(opd));
	    }
	    catch (SAXException e)
	    {	// instance document is invalid!
	    	valid=false;
	    }
	    context.createResponseFrom(valid);
	}

}
